/****************************************************************************
 * Copyright(c) 2000 Broadcom Corporation, all rights reserved.
 * Contains proprietary and confidential information.
 *
 * This source file is the property of Broadcom Corporation, and
 * may not be copied or distributed in any isomorphic form without 
 * the prior written consent of Broadcom Corporation. 
 *
 *
 *  Name: E R R O R . H
 *
 *  Description: This file contains macro and data structure definitions
 *  for MENU.
 *
 *  AUTHOR: Kevin Tran
 *
 *  HISTORY:    Kevin Tran        06/01/2000   Created
 *
 *******************************************************************/

#ifndef __ERROR_H__
#define __ERROR_H__

#include "general.h"

extern u08 t_err_type;
extern u32 t_errl1;
extern u32 t_errl2;
extern u32 t_errl3;
extern u32 t_errl4;
extern u32 t_errl5;
extern u32 t_errl6;
extern s08 *t_errs1;
extern s08 *t_errs2;
extern s08 *t_errs3;

#define	NO_PCI_BIOS		1
#define	NO_TIGON_BASEADDR	2
#define	NO_TIGON		3
#define BAD_CONSTANT		4
#define BAD_DATALINE		5
#define ADDR_LINE_SHORT		6
#define NO_SHARED_ACCESS	7
#define NO_DMA_MASTER		8
#define BAD_CKSUM		9
#define BAD_MAGIC_NUMBER	10
#define DMA_FAILURE		11
#define BAD_DATA		12
#define CONF_BYTE		13
#define CONF_HALF		14
#define RW_TEST_FAILURE		15
#define TIMER_FAILURE		16
#define MAILBOX_FAILURE		17
#define	NO_TIGON_INTLINE	18
#define	NO_ASIC_VERSION		19

extern void warning(s08 *message, int line);	   /* parse warning */
extern void error(s08 *message, s08 *s, int k);  /* non-fatal parse error */
extern void fatal_error(s08 *message, s08 *s, int k); /* fatal parse error */

extern void yyerror(s08 *error);		   /* needed by byacc */

extern void fatal_test_error(void);		   /* fatal test error */
extern void test_error(void);			   /* non-fatal test error */
extern void test_err_firstdma (s08 *s,
 			       u32 addr,
			       u08 exp,
			       u08 res,
			       u32 blen,
			       u32 doff,
			       u32 soff,
			       u32 itr);
extern void test_err_dma      (u32 addr,
		   	       u08 exp,
		   	       u08 res);
extern void test_warning(void);			   /* non-fatal test warning */

#endif /* __ERROR_H__ */
