/****************************************************************************
 * Copyright(c) 2000 Broadcom Corporation, all rights reserved.
 * Contains proprietary and confidential information.
 *
 * This source file is the property of Broadcom Corporation, and
 * may not be copied or distributed in any isomorphic form without 
 * the prior written consent of Broadcom Corporation. 
 *
 *
 *  Name: G E N E R A L. H
 *  FileName: $Header: /Source/Bcm44xx/b44diag/general.h 4     7/19/02 10:07a Ahui $
 *
 *  Description: This file contains utility routines for T3.
 *
 *  AUTHOR: Kevin Tran
 *
 *  HISTORY:    Kevin Tran        06/01/2000   Created
 *  $Log: /Source/Bcm44xx/b44diag/general.h $
 * 
 * 4     7/19/02 10:07a Ahui
 * Removed unused code
 * 
 * 3     3/07/02 5:05p Ahui
 *******************************************************************/

#ifndef __GENERAL_H__
#define __GENERAL_H__

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <assert.h>
#include "t3_prtf.h"
#ifdef EFI
#include "t3_efi.h"
#endif
#include "types.h"



#define MANU_NAME	"BCM440X Manufacture Testing Program"
#define APP_NAME	"BCM440X Engineering Diagnostics"



/* define for running without a tigon card */

/* indirection to do verbose-level-based printing */
#define printf   Printf
#define dprintf  Dprintf
#define iprintf  Iprintf
#define pprintf  Pprintf
#define eprintf  Eprintf

/* menu return type */ 
typedef int mret_t;

#ifdef EFI
#define bool BOOLEAN
#else
typedef enum {FALSE, TRUE} bool;
#endif

typedef struct
{
  u32 low;
  u32 high;
}Data64,*pData64;


#define HIGHWORD(d)	((d & 0xffff0000)>>16)
#define LOWWORD(d)	(d & 0x0000ffff)
#define HIGHBYTE(w)	((w & 0xff00)>>8)
#define LOWBYTE(w)	(w & 0x00ff)
#define HIGHNYBL(b)	((b & 0xf0)>>4)
#define LOWNYBL(b)	(b & 0x0f)

#define BYTE_SWAP(w)	( (((w) & 0xff000000) >> 24) |	 \
		          (((w) & 0x00ff0000) >> 8)  |   \
		          (((w) & 0x0000ff00) << 8)  |   \
		          (((w) & 0x000000ff) << 24) )

#define BYTE_SWAP_S(w)   ((((w) & 0xff00) >> 8) | \
		          (((w) & 0x00ff) << 8))

#define PAGESIZE	0x1000

#define SET_FLAG(v,f) {v |= (f);}
#define CLEAR_FLAG(v,f) { v &= ~(f);}
#define IS_FLAG(v,f) (v & (f))

/*************************************************************
 * externs
 *************************************************************/
extern char *versionStr;
extern char *dateStr;

#endif /* __GENERAL_H__ */

