/******************************************************************************/
/* The information contained in this file is confidential and proprietary to  */
/* Broadcom Corporation.  No part of this file may be reproduced or           */
/* distributed, in any form or by any means for any purpose, without the      */
/* express written permission of Broadcom Corporation.                        */
/*                                                                            */
/* (c) COPYRIGHT 2000 Broadcom Corporation, ALL RIGHTS RESERVED.              */
/*                                                                            */
/*                                                                            */
/* Module Description:                                                        */
/*                                                                            */
/*                                                                            */
/* History:                                                                   */
/*    02/25/00 Hav Khauv        Initial version.                              */
/******************************************************************************/

#ifndef LM_H
#define LM_H
#include "queue.h"
#include "bits.h"

/******************************************************************************/
/* Basic types. */
/******************************************************************************/

typedef char           LM_CHAR,    *PLM_CHAR;
typedef unsigned int   LM_UINT,    *PLM_UINT;
typedef unsigned char  LM_UINT8,   *PLM_UINT8;
typedef unsigned short LM_UINT16,  *PLM_UINT16;
typedef unsigned long  LM_UINT32,  *PLM_UINT32;
typedef unsigned long  LM_COUNTER, *PLM_COUNTER;
typedef void           LM_VOID,    *PLM_VOID;
typedef char           LM_BOOL,    *PLM_BOOL;

/* 64bit value. */

typedef struct {
#ifdef BIG_ENDIAN_HOST
    LM_UINT32 High;
    LM_UINT32 Low;
#else // BIG_ENDIAN_HOST 
    LM_UINT32 Low;
    LM_UINT32 High;
#endif // !BIG_ENDIAN_HOST 
} LM_UINT64, *PLM_UINT64;

typedef LM_UINT64 LM_PHYSICAL_ADDRESS, *PLM_PHYSICAL_ADDRESS;


#ifndef TRUE
#define TRUE           1
#endif /* TRUE */

#ifndef FALSE
#define FALSE          0
#endif /* FALSE */

#ifndef NULL
#define NULL                ((void *) 0)
#endif /* NULL */

#ifndef OFFSETOF
#define OFFSETOF(_s, _m)    ((LM_UINT32) MM_UINT_PTR(&(((_s *) 0)->_m)))
#endif /* OFFSETOF */


/******************************************************************************/
/* Constants. */
/******************************************************************************/

#define ETHERNET_ADDRESS_SIZE           6
#define ETHERNET_PACKET_HEADER_SIZE     14
#define MIN_ETHERNET_PACKET_SIZE        64      // with 4 byte crc. */
#define MAX_ETHERNET_PACKET_SIZE        1518    // with 4 byte crc. */
#define MIN_ETHERNET_PACKET_SIZE_NO_CRC 60
#define MAX_ETHERNET_PACKET_SIZE_NO_CRC 1514
#define MAX_ETHERNET_PACKET_BUFFER_SIZE 1536    /* A nice even number. */

#ifndef LM_MAX_MC_TABLE_SIZE
#define LM_MAX_MC_TABLE_SIZE            32
#endif 
#define LM_MC_ENTRY_SIZE                (ETHERNET_ADDRESS_SIZE+1)
#define LM_MC_INSTANCE_COUNT_INDEX      (LM_MC_ENTRY_SIZE-1)

typedef LM_UINT LM_STATUS, *PLM_STATUS;

typedef LM_UINT32 LM_REQUESTED_MEDIA_TYPE, *PLM_REQUESTED_MEDIA_TYPE;

typedef LM_UINT32 LM_MEDIA_TYPE, *PLM_MEDIA_TYPE;

typedef LM_UINT32 LM_LINE_SPEED, *PLM_LINE_SPEED;

typedef LM_UINT32 LM_DUPLEX_MODE, *PLM_DUPLEX_MODE;


typedef LM_UINT32 LM_POWER_STATE, *PLM_POWER_STATE;


typedef LM_UINT32 LM_TASK_OFFLOAD, *PLM_TASK_OFFLOAD;



typedef LM_UINT32 LM_FLOW_CONTROL, *PLM_FLOW_CONTROL;


typedef LM_UINT32 LM_WAKE_UP_MODE, *PLM_WAKE_UP_MODE;


typedef LM_UINT32 LM_COUNTER_TYPE, *PLM_COUNTER_TYPE;


typedef struct _LM_DEVICE_BLOCK *PLM_DEVICE_BLOCK;
typedef struct _LM_PACKET *PLM_PACKET;


#endif /* LM_H */







