/******************************************************************************/
/* The information contained in this file is confidential and proprietary to  */
/* Broadcom Corporation.  No part of this file may be reproduced or           */
/* distributed, in any form or by any means for any purpose, without the      */
/* express written permission of Broadcom Corporation.                        */
/*                                                                            */
/* (c) COPYRIGHT 2000 Broadcom Corporation, ALL RIGHTS RESERVED.              */
/*                                                                            *
 *  FileName: $Header: /Source/Bcm44xx/b44diag/mm.h 9     7/19/02 10:07a Ahui $
 *                                                                            */
/* Module Description:                                                        */
/*                                                                            */
/*                                                                            */
/* History:                                                                   */
/*    02/25/00 Hav Khauv        Initial version.                              *
 *  $Log: /Source/Bcm44xx/b44diag/mm.h $ *
 * 
 * 9     7/19/02 10:07a Ahui
 * Removed unused code
 * 
 * 8     7/11/02 1:02p Ahui
 * Clean up unused code.
 * 
 * 7     4/25/02 11:08a Ahui
 * 
 * 3     3/07/02 5:05p Ahui
 * Added sromutil support
 ******************************************************************************/

#ifndef MM_H
#define MM_H


#ifndef EFI
#define DbgBreakPoint()  { _asm int 3 }   
#endif

#include "tigon3.h"
#include "um.h"

#ifndef EFI
#include <i86.h>
#endif

/******************************************************************************/
/* Simple macros */
/******************************************************************************/

#define MM_Wait(_Microsec) util_wait_1us(_Microsec)

/* This macro converts the given value to an unsigned integer of pointer */
/* precision.  Pointer precision could either be a 32bit or 64bit depending */
/* on the target operating system. */
#ifdef EFI64
#define UINT_PTR                    __int64
#define MM_UINT_PTR(_ptr)           ((__int64) (_ptr))
#else
#define UINT_PTR                    LM_UINT32
#define MM_UINT_PTR(_ptr)           ((LM_UINT) (_ptr))
#endif

/* This macro converts the least significant 32 bit of a pointer to an */
/* unsigned 32 bit integer. */
#define MM_UINT32_PTR_LOW(_ptr)     ((LM_UINT32) ((UINT_PTR) (_ptr)))

/* This macro converts the most significant 32 bit of a pointer to an */
/* unsigned 32 bit integer. */
#ifdef EFI64
#define MM_UINT32_PTR_HIGH(_ptr)     ((LM_UINT32) (((UINT_PTR) (_ptr)) >> 32))
#else
#define MM_UINT32_PTR_HIGH(_ptr)     0
#endif

/* ((LM_UINT32) (((UINT_PTR) (_ptr)) >> 32)) */
/* Initialize a 64-bit address. */
#define MM_SET_ADDRESS(_Addr, _ptr)  _Addr.##Low = MM_UINT32_PTR_LOW(_ptr); \
                                     _Addr.##High = MM_UINT32_PTR_HIGH(_ptr);

/* Function macros. */



/* The size of the UM_PACKET structure. */
#define MM_PACKET_DESC_SIZE                     sizeof(UM_PACKET)

/******************************************************************************/
/* Spinlock macros for UNDI mode. */
/******************************************************************************/

#if USE_UNDI_VIEW || PCIX_TARGET_WORKAROUND

#define MM_ACQUIRE_UNDI_LOCK(_pDevice)                                      \
    NdisAcquireSpinLock(&((PUM_DEVICE_BLOCK) (_pDevice))->UndiLock);        \

#define MM_RELEASE_UNDI_LOCK(_pDevice)                                      \
    NdisReleaseSpinLock(&((PUM_DEVICE_BLOCK) (_pDevice))->UndiLock);        \

#else

#define MM_ACQUIRE_UNDI_LOCK(_pDevice)
#define MM_RELEASE_UNDI_LOCK(_pDevice)
    
#endif /* USE_UNDI_VIEW */
#endif /* MM_H */

