/********************************************************************
 * Copyright(c) 2000 Broadcom Corporation, all rights reserved.
 * Contains proprietary and confidential information.
 *
 * This source file is the property of Broadcom Corporation, and
 * may not be copied or distributed in any isomorphic form without 
 * the prior written consent of Broadcom Corporation. 
 *
 *  FileName: $Header: /Source/Bcm44xx/b44diag/t3_diag.c 11    7/19/02 10:07a Ahui $
 *
 *  Description: This file contains each individual tests
 *
 *********************************************************************/
#include <stdio.h>
#include <stdlib.h>
#include <fcntl.h>
#include <sys/stat.h>
#ifndef EFI
#include <io.h>
#include <conio.h>
#endif

#include "general.h"
#include "t3_gdata.h"
#include "t3_util.h"
#include "t3_tests.h"
#include "t3_mdiag.h"
#include "fw_img.h" 
#include "um.h"
#include "t3_mii.h"
#include "t_io.h"
#include "t3_intr.h"
#include "um.h"
#include "t3_eprom.h"
#include "t3_flash.h"
#include "pci.h"
#include "t3_cli.h"
#include "Cl4xsb.h"
#define MBUF_MEM_TEST_CASE  8

#define MBUF_TEST_BUFFER_SIZE  0x1000
#define MBUF_TEST_BUFFER_SIZE32 (MBUF_TEST_BUFFER_SIZE/4)
#define MEM_CFG_MBUF_TOP (MEM_INTERNAL_MBUF_TOP < global.diag_cb.mem.sram_mbuf_end ? MEM_INTERNAL_MBUF_TOP : global.diag_cb.mem.sram_mbuf_end)
//static  u32 buffer[MBUF_TEST_BUFFER_SIZE32];


/* **workaround**, with irq shared with other device, such as Intel NIC
   the memory read, once a while returns invalid data, the work around this
   on the case of data mismatch, give it another chance to read.
   This applies to the following "check_data" macro */
#define SRAM_IREAD_RETRY 3    
   

#define check_data(a,d,rf,e) \
{                          \
    u32 rdata;             \
                           \
/*    global.checkZero = (d==0) ? 1: 0; */\
    rdata = rf(a);         \
	if (rdata != d)        \
    {                      \
        u32 data;          \
        read_configuration_dword(CURRCARD.bus_number,  /* for debug trace */ \
                                 CURRCARD.device_and_function, \
                                 0x20,&data);   \
        return test_failed3(e,rdata,a,d);\
    }                  \
    check_abort();         \
}

#define rw_test(a,d,wf,rf,e) \
{                            \
    wr_func(a,d);            \
    check_data(a,d,rf,e);    \
}


#define MAX_TEST_PATTERN 4


#ifndef IKOS

#define RJ45_TEST_MODE 3

//static s08 *RJ45_TestMode[RJ45_TEST_MODE] = {"10","100","1000"};

#endif /* ikos */
										
#define RANDOM_KEY 0x7ab5
#define SEED 0x7abf5ba6

#define ALLONE   (BIT_0|BIT_1|BIT_2)
#define ALLDEVICES ALLONE
#define ALLZERO  0
#define NOCHANGE 0xffffffff



/*******************************************************/


/*******************************************************/
/*
 * pattern test
 */


/*******************************************************/
/*
 * Reliability pattern test
 */

/*******************************************************/
/*
 * altenate pattern test
 */

/*******************************************************/
/*
 * altenate pattern test
 */


/*******************************************************/
/*
 * walking one bit test
 */


/*******************************************************/
/*
 * random data test
 */


/*******************************************************/
/*
 * random data test
 */

/*******************************************************/
/*
 * random data test
 */


/*******************************************************/
/*
 * sram memory test 
 */

/*******************************************************/
/*
 * Reliability sram memory test 
 */

/*******************************************************/

/*******************************************************/
/*
 * DMA test Priority
 */

/*******************************************************/
/*
 * check dma data content
 */

/*******************************************************/

/*******************************************************/

/*******************************************************/
/* this test make sure data cannot be written to vpd readonly area */

/*******************************************************/

/*******************************************************/

/********************************************************/    

/*******************************************************/

/*******************************************************/

/*******************************************************/

/********************************************************/    
/****************** public routines *********************/
/********************************************************/    

/*
 *
 */

/*
 * Reliability memory test
 */

/********************************************************/ 
/* this is a workaround. When speed 10 link has been connected, 
   the receive block register requires delay to access. To avoid delay,
   we are forcing the mac/phy to speed 1000 during test. 
   The bug should be fixed in C0.
*/
//static u32 mac_reg;
//static u16 phy_reg;


/********************************************************/ 
/*
 * A1. Indirect register Test 
 */
int indi_reg_test(void * dummy)
{
	test_showDot();
	return SB4xDiagTestRegisters(1, 1);
}

/*
 * A2. Control Register Test 
 */
int ctrl_reg_test(void * dummy)
{
	test_showDot();

	return SB4xDiagTestRegisters(1, 0);
    
}


/*
 * A3. Interrupt Test
 */
#ifdef EFI
/* Since polling every 500 ms in EFI, need to wait a little longer. */
#define MAX_INTERRUPT_WAIT 1000
#else
#define MAX_INTERRUPT_WAIT 10
#endif
int interrupt_test(void * dummy)
{
    
		ULONG j;
		
		test_showDot();

		CURRCARD.gottestint = FALSE;
		CURRCARD.inttest = TRUE;
		reset();
		RegWr(0x1F94,2);
		RegWr( REGOFFSET(intmask), I_TO);
		// SGS - 2 should be 20 ns but have interrupt latency as well
		RegWr( REGOFFSET(gptimer), 2);


		for(j = 0; j < MAX_INTERRUPT_WAIT; j++)
		{
			if(CURRCARD.gottestint==TRUE)
			{
				break;
			}
			MM_Wait(10);
		}
		
		reset();
		
		return (CURRCARD.gottestint) ? test_passed():test_failed0(ERR_INTERRUPT);

}

/***************************************************************
 *  diag_bistReset
 *  Reset bist block 
 ***************************************************************/


/***************************************************************
 *  diag_bistClockLo
 *  Set bist clock level to LO 
 ***************************************************************/

/***************************************************************
 *  diag_bistClockHi
 *  Set bist clock level to HI 
 ***************************************************************/

/***************************************************************
 *  diag_bistEnable
 *  Enable bist operation 
 ***************************************************************/

/***************************************************************
 *  diag_bistEnable
 *  Enable bist operation 
 ***************************************************************/

/***************************************************************
 *  diag_bistShiftDataIn
 *  Serially shift in data 
 ***************************************************************/

/***************************************************************
 *  diag_bistShiftDataOut
 *  Serially shift out data 
 ***************************************************************/

/***************************************************************
 *  diag_bistEnable
 *  Enable bist operation 
 ***************************************************************/

/***************************************************************
 *  diag_bistCompareData
 *  Compare data in In and Ex buffers 
 ***************************************************************/
int diag_bistCompareData(u16 bistDataSize)
{
    u08 *p = global.bistDataOut;
    u08 *q = global.bistDataEx;
    
    while(bistDataSize--)
    {
        if(*p++ != *q++)
            return test_failed3(ERR_BIST_DATA_MISCMP, BIST_DATA_SIZE - bistDataSize, *p, *q);
    }
    return NO_ERROR;
}

/*****************************************************************
 * diag_loadBistDataFile(char * fn,u32 * buff, int len)
 *****************************************************************/
int diag_loadBistDataFile(char * fn, u08 *buff, int len)
{
    u08 *p;
	u08 a,b;
    FILE * ifile;
    
    if ((ifile = fopen(fn,"r")) == NULL)
        return 0;
   
    p=buff;
    while (!feof(ifile))
    {
        a = fgetc(ifile);
        b = (u08)atoi(&a);
        if((a == '0') || (a == '1'))
            *p++ = b;
    }
    fclose(ifile);
    return 1;
}

/***************************************************************
 *  A4. BIST (built in self test)
 ***************************************************************/
int diag_bist_test(void * dummy)
{	
	test_showDot();
	return SB4xDiagTestIntMemory(1);
}

/****************************************************************************
 * B1. Scratch Pad Sram Test
 ****************************************************************************/


/*
 * B2. bd sram test
 */

/*
 * B3. dma sram test
 */

/*
 * B4. mbuf sram test
 */

/*
 * B5. mbuf sram test via dma
 */

/* 
 * B6. mbuf special test
 */

/*
 * B7. External SRAM memory test
 */

/*
 * B8. Reliability board sram test
 */

/*
 * C1. eeprom read/write test
 */
int eeprom_rw_test(void * dummy)
{
	test_showDot();
	if(SB4xDiagTestEEPROM(1)==NO_ERROR)
		return test_passed();
	else
		return test_failed0(ERR_BAD_CHECKSUM);
}


/*
 * C2. CPU test
 */

/*
 * C3. DMA test
 */
 
int Link_test(void * dummy)
{
	u16 temp;
	u08 i;
	test_showDot();
	for (i=0;i<15;i++)
	{
		MM_Wait(100000);
	}
	temp=miird(GMII_REG_STATUS_SUMRY);
	return link_status(temp & 0x4);
}
/*
 * C2. MII test
 */
int MII_test(void * dummy)
{
	test_showDot();
	return SB4xDiagTestMii (1);
}

/*
 * C5. VPD test
 */


/*
 * sub test for ASF test 
 */

#define MAX_ATTN_LOC 16
#define TX_EVENT_BITS 0x50ae 
//#define TX_EVENT_BITS 0x108e
#define RX_EVENT_BITS 0x150ab
#define RX_EVENT_BIST ()
/*
 * C6. ASF test
 */

/*
 * C7. ROM test
 */
 
int LED_test(void *para)
{
	test_showDot();
	SB4xDiagTestLEDs(1,15);
	return test_passed();
		
}
/*******************************************************
 * function loopback_test, Copper_IntLoop_test or TBI_IntLoop_test
 *
 * input: none
 * 
 * output: none
 * 
 * return: test result
 *
 *******************************************************/

/*******************************************************/

/*******************************************************
 * function IntLoop_test -- calls TBI_IntLoop_test or Copper_IntLoop_test
 *   do MAC loopback test
 * input: cookie -- not used
 * 
 * output: none
 * 
 * return: test result
 *
 *******************************************************/

int IntLoop_test(void * cookie)
{
    U32 temp;
	test_showDot();
	temp=SB4xDiagTestLoopBack(1,0,2000,10);
	if (temp == NO_ERROR)
		return test_passed();	
	else
		return test_failed0(temp);  
    //checkDriverIsLoaded();
	
    //util_DbgPrintf("\nTBI Mode = %d", TBIMODE());
    //return (TBIMODE() ? TBI_IntLoop_test() : Copper_IntLoop_test());
}


/*******************************************************
 * function PhyLoopTest
 *   Copper_PhyLoop_test or TBI_PhyLoop_test
 *
 * input: none
 * 
 * output: none
 * 
 * return: test result
 *
 *******************************************************/

/*******************************************************/

/*******************************************************
 * function Phy_loopback_test -- calls Copper_PhyLoop_test or TBI_PhyLoop_test
 * input: cookie -- not used
 * 
 * output: none
 * 
 * return: test result
 *
 *******************************************************/

int PhyLoop_test(void * cookie)
{
    U32 temp;
	test_showDot();
	temp=SB4xDiagTestLoopBack(1,1,2000,10);
	if (temp == NO_ERROR)
		return test_passed();	
	else
		return test_failed0(temp);  
}


int External_Loop_test_100(void * cookie)
{
	U32 temp;
	test_showDot();
	temp=SB4xDiagTestLoopBack(1,3,2000,10);
	if (temp == NO_ERROR)
		return test_passed();	
	else
		return test_failed0(temp);  
}
/*******************************************************
 * function External_Loop_test_10 -- 
 * input: cookie -- not used
 * 
 * output: none
 * 
 * return: test result
 *
 *******************************************************/

int External_Loop_test_10(void * cookie)
{
	U32 temp;
	test_showDot();
	temp=SB4xDiagTestLoopBack(1,4,2000,10);
	if (temp == NO_ERROR)
		return test_passed();	
	else
		return test_failed0(temp);  
}



/*******************************************************
 * A5. MSI test
 *******************************************************/



/*******************************************************************
 *
 *  $Log: /Source/Bcm44xx/b44diag/t3_diag.c $
 * 
 * 11    7/19/02 10:07a Ahui
 * Removed unused code
 * 
 * 10    6/13/02 10:21a Ahui
 * Reduced wait time in link_test.
 * 
 * 9     6/11/02 3:54p Ahui
 * Reduced led flast in ledtest from 50 to 15 times
 * 
 * 8     5/29/02 6:34p Ahui
 * In manufacturing mode, external loopback test has been separated to 2
 * tests, C3 and C4.  C3 is 100BT and C4 is 10BT
 * 
 * 7     4/25/02 11:06a Ahui
 * 
 * 3     3/07/02 5:05p Ahui
 * Added sromutil support
 *****************************************************************/

