/****************************************************************************
 * Copyright(c) 2000 Broadcom Corporation, all rights reserved.
 * Contains proprietary and confidential information.
 *
 * This source file is the property of Broadcom Corporation, and
 * may not be copied or distributed in any isomorphic form without 
 * the prior written consent of Broadcom Corporation. 
 *
 *
 *  Name: T 3 _ F L A S H . H
 *
 *  Description: This file contains serial flash/EEPROM routines for T3.
 *
 *  AUTHOR: Stephen Keung
 *
 *******************************************************************/

#ifndef __T3_FLASH_H__
#define __T3_FLASH_H__

#define FLASH_CFG1 t_readmem32(OFFSETOF(T3_STD_MEM_MAP,Flash.Config1))
int  flash_BufferedFlash(void);
u32  flash_LogicalToPhysicalAddress(u32 addr);
u32  flash_PhysicalToLogicalAddress(u32 addr);
int  flash_showMode(void);
int  flash_isSupported(void);
int  flash_read_word(u32 flash_addr,u32* wr_data);
void flash_fill_blk(u32 address, u32 end,u32 wr_data, int verbose);
int  flash_program(u32 addr, u32 num_word, u32* buff, int verbose);
int  flash_oldMethod(void);
u32  flash_read(u32 addr);
void releaseFlash(void);
int  lockFlash(void);

#endif /* __T3_FLASH_H__ */
