#ifndef __DL_TX_H__
#define __DL_TX_H__

#include "protocol.h"
#include "t3_cmd.h"

typedef struct TX_TEST_INFO
{
/* menu configurable variables */
    MAC_ADDR dest_mac;
    MAC_ADDR src_mac;
    u16 total_packet_size;
    u08 packet_type;
#define PKT_TYPE_ETH2   1
#define PKT_TYPE_802_3  2
#define PKT_TYPE_SNAP   3
    u16 layer2_prot;
    u16 layer3_prot;
    IP_ADDR src_ip;
    IP_ADDR dest_ip;
    u16 src_port;
    u16 dest_port;
    u16 pattern;
#define PKT_PATTERN_INC         1
#define PKT_PATTERN_RANDOM      2
#define PKT_PATTERN_ALL_ZEROS   3
#define PKT_PATTERN_ALL_FFS     4
#define PKT_PATTERN_ALL_AA55    5
#define PKT_PATTERN_ALL_55AA    6
#define PKT_PATTERN_SPECIAL     7
#define PKT_PATTERN_FILE		8
    u08 ip_chksum_offload;
    u08 tcp_udp_chksum_offload;
    u16 vlan_tag;
    u08 insert_vlan;
    u08 tcp_udp_pchksum_only;
    u32 ip_option_len;
    u32 tcp_option_len;
    int random_ip_hdr;
    int random_tcpudp_hdr;

// cfg variables used for both txpkt & blast
    int start_tx_len;
    int curr_tx_len;
    int end_tx_len;
    u32 num_tx_packets;
    int pause;    
    u16 ip_total_len;
    u32 tx_ipg;
    u32 inc_len;     // inc_len
    int burst_length;
    
// txpkt cfg variables
    int max_number_fragments;
    int use_random_fragments;
    int use_random_pkt_len;
    int min_block_size;
    u32 start_ring_num;
    int insert_frag_info;
    u16 flags;
    int multi_tx_ring_test;
    int num_tx_ring;
    int packet_per_ring;
    int dont_init_data;
    int buffer_offset;
    int ip_frag_count;
    int insert_raw_checksum;
    int standard_seg;

// blast cfg variable
    int tx_enable;
    int rx_enable;
    char * sniffFile;
    int host_loopback;
    int tcp_seg_test;
    int use_txcfg_parms;
    int tx_tprot_pkt;
    int sw_tx_crc_gen;
    int num_rx_ring;
    int tx_th;
    int rx_th;
    int rx_crc_check;
    int stop_on_fail;
    u16 check_len;
    int hlb_gen_tx_crc;
	u08 use_static_buffer;
    u08 checkDMAWriteStatus;

// runtime variable
    u16 ip_iden_no;
    u32 tx_enq;
    int ip_fragmentation;
    u16 current_ip_frag_offset;
    int ip_frag_last_fragment;
    int current_ip_frag_count;
    int machdr_len;

}TX_TEST_INFO,*pTX_TEST_INFO;


int txInitCfg(command_ptr cmd);

#endif