/****************************************************************************
 * Copyright(c) 2000 Broadcom Corporation, all rights reserved.
 * Contains proprietary and confidential information.
 *
 * This source file is the property of Broadcom Corporation, and
 * may not be copied or distributed in any isomorphic form without 
 * the prior written consent of Broadcom Corporation. 
 *
 *
 *  Name: T3 _ U M . C
 *  FileName: $Header: /Source/Bcm44xx/b44diag/t3_um.c 10    7/19/02 10:07a Ahui $
 *
 *  Description: This file contains Upper Module (UM) routines to
 *               to interface with LM and "upper layer" diagnostics.
 *
 *  AUTHOR: Kevin Tran
 *
 *  HISTORY:    Kevin Tran        06/01/2000   Created
 *  FileName: $Log: /Source/Bcm44xx/b44diag/t3_um.c $
 * 
 * 10    7/19/02 10:07a Ahui
 * Removed unused code
 * 
 * 9     7/11/02 1:02p Ahui
 * Clean up unused code.
 * 
 * 8     6/13/02 9:59a Ahui
 * Clean up unused code
 * 
 * 7     4/25/02 11:03a Ahui
 * 
 * 3     3/07/02 5:05p Ahui
 * Added sromutil support
 ******************************************************************************/

#include <stdio.h>
#include <stdlib.h>
#include <graph.h>
#include "general.h"
#include "tigon3.h"
#include "error.h"
#include "t_io.h"
#include "pci.h"
#include "eeprom.h"
#include "um.h"
#include "t3_util.h"
#include "t3_gdata.h"
#include <time.h>
#include "t3_intr.h"
#include "t_io.h"



static NIC_BLK NicCtrlBlk[MAX_NUM_NIC];

pNIC_BLK UM_GetNIC()
{
  return &NicCtrlBlk[get_currcard_index()];
}

int t3_shutdown()
{
  PLM_DEVICE_BLOCK pDevice;
  PUM_DEVICE_BLOCK pUmDevice;
  card_t *card_p;
  pNIC_BLK pNicBlk;

  if (((card_p = get_currcard()) == NULL) ||
      (card_p->lm_cb_ptr == NULL) ||
      ((pNicBlk = UM_GetNIC()) == NULL))
    return -1;
  
  pUmDevice = (PUM_DEVICE_BLOCK)card_p->lm_cb_ptr;
  pDevice = &pUmDevice->LmDevice;

 
  if (UM_FreeResources(pUmDevice) < 0)
    return -1;

  
  card_p->lm_cb_ptr = (void *)NULL;
  pNicBlk->DeviceInst = NULL;
  free(pDevice);

  return 0;
}

/******************************************************************************/
/* Description:                                                               */
/*    Sends a packet on the wire or queue it up for transmission.             */
/*                                                                            */
/* Return:                                                                    */
/*    None.                                                                   */
/******************************************************************************/

int UM_FreeResources(PUM_DEVICE_BLOCK pDevice)
{
  int i;

  if (pDevice == NULL)
    return -1;

  /* Look for an unused entry */
  for (i = 0; i < NUM_OF_RESOURCES; i++)
    {
      if (pDevice->UsedResource[i] != NULL)
      {
        
          free(pDevice->UsedResource[i]);
      }         
    }

  return 0;
}

dbg_printf() {}

