/****************************************************************************
 * Copyright(c) 2000 Broadcom Corporation, all rights reserved.
 * Contains proprietary and confidential information.
 *
 * This source file is the property of Broadcom Corporation, and
 * may not be copied or distributed in any isomorphic form without 
 * the prior written consent of Broadcom Corporation. 
 *
 *
 *  Name: BLAST.c
 *  FileName: $Header: /Source/Bcm44xx/b44diag/blast.c 10    7/19/02 10:07a Ahui $
 *
 *  Description: This file contains utility routines for T3.
 *
 *  AUTHOR: Kevin Tran
 *****************************************************************************/
#include "general.h"
#include "t3_gdata.h"
#include "t3_util.h"
#include "blast.h"
#include "t3_win.h"
#include "t3_tx.h"
#include "t3_intr.h"
#include "t3_cli.h"
#include "t3_comm.h"



/****************************************************************************
    public function 
*****************************************************************************/
int blastInitCfg(command_ptr cmd)
{
    pTX_TEST_INFO txInfo = &CURRCARD.txInfo;

    txInfo->tx_enable = cmd_optionEntered(cmd,'t');
    txInfo->host_loopback = cmd_optionEntered(cmd,'h');
    txInfo->rx_enable = cmd_optionEntered(cmd,'r') ;
    txInfo->sniffFile = cmd_optionEntered(cmd,'f') ? cmd_optionValue(cmd,'f').valueStr : NULL;
    txInfo->curr_tx_len = txInfo->start_tx_len = pValue32(cmd,'l');
    txInfo->end_tx_len = pValue32(cmd,'e');
    txInfo->tcp_seg_test = cmd_optionEntered(cmd,'S');
    txInfo->use_txcfg_parms = cmd_optionEntered(cmd,'p');
    txInfo->num_tx_packets = pValue32(cmd,'n');
    txInfo->burst_length = pValue32(cmd,'c');
    txInfo->ip_total_len = pValue32(cmd,'a');
    txInfo->tx_tprot_pkt = cmd_optionEntered(cmd,'m');
    txInfo->sw_tx_crc_gen = cmd_optionEntered(cmd,'q');
    txInfo->inc_len = cmd_optionEntered(cmd,'i');
    txInfo->tx_ipg = pValue32(cmd,'d');
    txInfo->num_rx_ring = pValue32(cmd,'o');
    txInfo->tx_th = pValue32(cmd,'z');
    txInfo->rx_th = pValue32(cmd,'g');
    txInfo->rx_crc_check = cmd_optionEntered(cmd,'k');
    txInfo->stop_on_fail = cmd_optionEntered(cmd,'s');
    txInfo->check_len = cmd_optionEntered(cmd,'x');
    txInfo->hlb_gen_tx_crc = cmd_optionEntered(cmd,'j');
    txInfo->pause = cmd_optionEntered(cmd,'P');
    txInfo->use_static_buffer = cmd_optionEntered(cmd,'A');
    txInfo->checkDMAWriteStatus = cmd_optionEntered(cmd,'W');
    if (cmd_optionEntered(cmd,'R'))
        com_enable();
    return NO_ERROR;
}

